#include <qpainter.h>
#include <kapp.h>
#include <kaction.h>
#include <kmenubar.h>
#include <kstdaccel.h>
#include <qslider.h>
#include <qlcdnumber.h>
#include "kbasicdemowindow.moc"

KBasicDemoWindow :: KBasicDemoWindow() :
numPoints(0),
distance(0)
{	
	setCaption("KDE-Demo");
	
	oneMoreAction = new KAction ("Eins &mehr malen", CTRL+Key_M, this, SLOT(drawOneMore()), this);
	// Bedeutung: Name + Menkrzel, "Accelerator", Empfnger, Slot, Elternfenster
	clearAction = new KAction ("&Lschen", CTRL+Key_L, this, SLOT(clearDrawing()), this);
	KAction* quitAction = new KAction ("B&eenden", KStdAccel::quit(), KApplication::kApplication(), SLOT(closeAllWindows()), this);
	// KApplication::kApplication() zeigt auf das globale Anwendungsobjekt

	QPopupMenu *myMenu = new QPopupMenu();
	oneMoreAction->plug(myMenu);
	clearAction->plug(myMenu);
	myMenu->insertSeparator();
	quitAction->plug(myMenu);
	// *oneMoreAction etc. werden nachher automatisch zerstrt; kein delete im Destruktor ntig

	menuBar()->insertItem ("&Testmen", myMenu);
	// MyMenu wird spter von menuBar zerstrt; kein delete im Destruktor ntig

	// ein Schieberegler ************

	QSlider* mySlider = new QSlider(-20, 20, 5, 0, Qt::Horizontal, this);
	mySlider->setGeometry(10, 30, 100, 20);
	mySlider->show();
	
	// verdrahten (Sender, sein Signal, Empfnger, dessen Slot)
	connect(mySlider, SIGNAL(valueChanged(int)), this, SLOT(moveDrawing(int)));
	// keine Namen fr Argumente angeben, sonst Fehler bei Makros

	// eine LED-Anzeige **************
	
	QLCDNumber* myLcd = new QLCDNumber(2, this); // zwei Stellen
	myLcd->setGeometry(120, 30, 40, 40);
	connect(this, SIGNAL(gotSoManyObjects(int)), myLcd, SLOT(display(int)));

	// *mySlider und *myLcd werden als Kind-Widgets nachher automatisch zerstrt; kein delete im Destruktor ntig

	// Statuszeile setzen

	statusBar()->message("kein Objekt vorhanden");
	// Knnte man noch machen; hier nicht ntig, weil Anfangswert stimmt:
	emit gotSoManyObjects(numPoints);
}

KBasicDemoWindow :: ~KBasicDemoWindow()
{
}

void KBasicDemoWindow :: drawOneMore()
{
	if(numPoints >= 10)
	// kann eigentlich nie passieren, wegen Disable
	{
		return;
	}
	
	x[numPoints] = 10+(numPoints*41)%100;
	y[numPoints] = 60+(numPoints*53)%71;
	++numPoints;

	clearAction->setEnabled(true);
	if(numPoints == 10)
	{
		oneMoreAction->setEnabled(false);
	}

	QString s;
	if(numPoints == 1)
	{
		s = "ein Objekt gezeichnet";
	}
	else
	{
		s.setNum(numPoints);
		s += " Objekte gezeichnet";
	}
	statusBar()->message(s);
	emit gotSoManyObjects(numPoints); // Nachricht senden

	update(); // Neuzeichnen anfordern
}

void KBasicDemoWindow :: clearDrawing()
{
	numPoints = 0;

	clearAction->setEnabled(false);
	oneMoreAction->setEnabled(true);

	statusBar()->message("kein Objekt vorhanden");
	emit gotSoManyObjects(numPoints); // Nachricht senden

	update(); // Neuzeichnen anfordern/
}

void KBasicDemoWindow :: moveDrawing(int value)
{
	distance = value;
	update(); // Neuzeichnen anfordern
}

void KBasicDemoWindow :: paintEvent (QPaintEvent *dummy)
{
	QPainter myPainter(this);

	QPen redPen(Qt::red, 2);
	myPainter.setPen(redPen);

	QBrush blackBrush(Qt::black);
	myPainter.setBrush(blackBrush);

	for(int i=0; i<numPoints; i++)
	{
		myPainter.drawEllipse(x[i] + distance, y[i], 10, 10);
	}

	// zum Testen auf Double-Buffering:
	/* myPainter.eraseRect(0, 0, 499, 499);
	for(int i=0; i<10000; i++)
	{
		myPainter.drawEllipse((i*841)%497, (i*751)%481, 10, 10);
	} */
}



